// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rc_common_msgs:msg/CameraParam.idl
// generated code does not contain a copyright notice

#ifndef RC_COMMON_MSGS__MSG__DETAIL__CAMERA_PARAM__STRUCT_H_
#define RC_COMMON_MSGS__MSG__DETAIL__CAMERA_PARAM__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'line_source'
// Member 'extra_data'
#include "rc_common_msgs/msg/detail/key_value__struct.h"

/// Struct defined in msg/CameraParam in the package rc_common_msgs.
/**
  * Camera parameters that relate to a published image
 */
typedef struct rc_common_msgs__msg__CameraParam
{
  /// Header with timestamp and frame_id to which the parameters belong
  std_msgs__msg__Header header;
  /// True in case of a color camera
  bool is_color_camera;
  /// Exposure time of the camera in seconds
  float exposure_time;
  /// Gain factor in dB
  float gain;
  /// Line status for DigitalIO control according to GenICam SFNC:
  /// Current status of all available line signals in a single bitfield
  uint32_t line_status_all;
  /// Line sources for DigitalIO control according to GenICam SFNC:
  /// Specifies for each line which internal acquisition or I/O source
  /// signal is output on the respective line.
  ///
  /// The keys define the lines, the values define the sources; e.g.
  /// [ {key: "out1", value: "ExposureActive"},
  /// {key: "out2", value: "Low"},
  /// ...
  /// ]
  rc_common_msgs__msg__KeyValue__Sequence line_source;
  /// Additional optional camera parameters as key value pairs
  rc_common_msgs__msg__KeyValue__Sequence extra_data;
} rc_common_msgs__msg__CameraParam;

// Struct for a sequence of rc_common_msgs__msg__CameraParam.
typedef struct rc_common_msgs__msg__CameraParam__Sequence
{
  rc_common_msgs__msg__CameraParam * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_common_msgs__msg__CameraParam__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RC_COMMON_MSGS__MSG__DETAIL__CAMERA_PARAM__STRUCT_H_
